#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Nov 15 13:37:43 2021

@author: jan

funtions takes an image and the area of the bubble, and returns the variance of the laplacian of the area
"""

import cv2
from math import sin, cos
import math
#import qualipy

import matplotlib.pyplot as plt
from skimage import io

def variance_of_laplacian(img):

    return cv2.Laplacian(img, cv2.CV_32F).var()
    

def tenengrad(img):
    
    return qualipy.utils.focus_measure.TENG(img)

def blur_detection_of_area(img, pos_x, pos_y, major, minor, orientation_angle, bubblePlot):

    Pos_x = float(pos_x)
    Pos_y = float(pos_y)
    Major = float(major)
    Minor = float(minor)
    Orientation_angle = float(orientation_angle)


    #calculating the needed windows in the image, where the bubble is, via axis transformation (calculating using formula from: https://math.stackexchange.com/questions/91132/how-to-get-the-limits-of-rotated-ellipse)
    
    if (not(Orientation_angle > math.pi/4 and Orientation_angle < math.pi*3/4)) and (not (Orientation_angle > math.pi*5/4 and Orientation_angle < math.pi*7/4)):
        x_max = (Major**2 * cos(Orientation_angle)**2+ Minor**2 *sin(Orientation_angle)**2)**(1/2)
        y_max = (Major**2 * sin(Orientation_angle)**2+ Minor**2 *cos(Orientation_angle)**2)**(1/2)

    else:
        x_max = (Minor**2 * cos(Orientation_angle)**2+ Major**2 *sin(Orientation_angle)**2)**(1/2)
        y_max = (Minor**2 * sin(Orientation_angle)**2+ Major**2 *cos(Orientation_angle)**2)**(1/2)
    
    #build in function to sort out values that go beyond the picture( below zero or bigger than pictures size)
    heigth_img , width_img = img.shape
    #print("Pos")
    #print(Pos_x)
    #print(Pos_y)
    #print(x_max)
    #print(y_max)
    #x_max = 20
    #y_max = 20
    
       
    p_1 = round(Pos_x - x_max) 
    p_2 = round(Pos_x + x_max) 
    p_3 = round(Pos_y - y_max)
    p_4 = round(Pos_y + y_max)
    #print("p")
    #print(p_1)
    #print(p_2)
    #print(p_3)
    #print(p_4)

    if 0<= p_1 and p_2  <= width_img and 0<= p_3 and p_4 <= heigth_img:
        img_cropped = img[p_3 : p_4, p_1 : p_2] 
        
        if bubblePlot==True:
            return plt.imshow(img_cropped)

        try:
            var_lap = variance_of_laplacian(img_cropped)
            #tenengrad = tenengrad(img_cropped)
            return var_lap
        except :
            return 0
    else:
        return 0

    
    return var_lap
    
