from skimage import io
from skimage import util
from skimage import exposure
from skimage.restoration import rolling_ball, ellipsoid_kernel
from skimage.color import rgb2gray

def img_processing(ImgDir):
    radius = 3
    norm_radius = radius / 255
    kernel = ellipsoid_kernel((radius * 2, radius * 2), norm_radius * 2)
    image = io.imread(ImgDir)
    img = rgb2gray(image)
    image_inverted = util.invert(img)
    background_inverted = rolling_ball(image_inverted, kernel=kernel)
    filtered_image = util.invert(image_inverted - background_inverted)
    img_adapteq = exposure.equalize_adapthist(filtered_image, clip_limit=0.01)

    return img_adapteq