# readme.md

## Installation

---

The code is compatible with Python 3.8.0, but should also work with other versions.

For CPU usage, please install the required packages using conda with the following procedure. At first, the packages listed in the requirements.txt file can be installed using `pip`

```python
pip install -r requirements.txt
```

Note: Depending on your Python installation, you may need to use `pip3`  instead of `pip`.

For GPU usage, please create first an enviroment using conda with the code from [https://github.com/CSBDeep/CSBDeep/tree/master/extras#conda-environment](https://github.com/CSBDeep/CSBDeep/tree/master/extras#conda-environment) as:

```python
conda env create -f https://raw.githubusercontent.com/CSBDeep/CSBDeep/master/extras/environment-gpu-py3.8-tf2.4.yml
```

Note: This enviroment can then be activate by entering ‘’conda activate csbdeep‘’ and deactivated by using ‘’ conda deactivate csbdeep’’.

For GPU support, the installation of the specific version of CUDA is necessary and it can be install via 

```python
pip install mxnet-cu102==1.7.0
```

You may then need to install any missing packages, or upgrade and downgrade some packages to a specific version.

Afterwards this enviroment should be sufficient for executing the script.